#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sched.h>

#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_lxrt.h>

#define MSG_DELAY 	1E9
#define MSG_LOOPS	12

main()
{
	unsigned long mtsk_name = nam2num("SRV");
        unsigned long btsk_name = nam2num("CLT");
	int count, msg, rep;
	RT_TASK *mtsk, *btsk, *err;
	struct sched_param mysched;

	mysched.sched_priority = 99;

	if( sched_setscheduler( 0, SCHED_FIFO, &mysched ) == -1 ) {
	puts(" ERROR IN SETTING THE SCHEDULER UP");
	perror( "errno" );
	exit( 0 );
 	}       

printf("CLT pid %d\n", getpid());

	mlockall(MCL_CURRENT | MCL_FUTURE);

 	if (!(btsk = rt_task_init(btsk_name, 0, 0, 0))) {
		printf("CANNOT INIT CLIENT TASK\n");
		exit(1);
	}

        rt_task_make_periodic(btsk, rt_get_time(), nano2count(1E9));

	printf("CLT TASK: name = %lx, address = %p(%p).\n", btsk_name, btsk, this_rt_task);

 	if (!(mtsk = rt_get_adr(nam2num("SRV")))) {
		printf("CANNOT FIND SRV TASK\n");
		exit(1);
	}

	msg = 0;
	count = MSG_LOOPS;
	while( count-- ) {
//		printf("CLT TASK SENDS MESSAGE %d TO SRV TASK\n", msg );
		err = rt_rpc(mtsk, msg, &rep);
		if( err != mtsk ) {
			printf("CLT: rt_rpc() failed\n" );
			break;
			}
//	        printf("CLT TASK GETS REPLY    %d FROM SRV TASK\n", rep );
	        rt_sleep(nano2count(1E9));
		msg = rep ;
		}

	printf("CLT TASK DELETES ITSELF\n");
	rt_task_delete(btsk);
}
