#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sched.h>

#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_lxrt.h>

#define SLEEP_LOOPS	2
#define DELAY		5E4
#define MSG_DELAY	1E9
#define MSG_LOOPS	12

main()
{
	unsigned long mtsk_name = nam2num("SRV");
        unsigned long btsk_name = nam2num("CLT");
	int msg;
	RT_TASK *btask, *mtsk, *rcvd_from;
	int i, dist[10000], pid, count, zeroi;
	struct sched_param mysched;
        unsigned long sem_name  = nam2num("SEM");
        SEM *sem;

        memset( dist, 0, sizeof(dist));

	mysched.sched_priority = 99;

	if( sched_setscheduler( 0, SCHED_FIFO, &mysched ) == -1 ) {
		puts(" ERROR IN SETTING THE SCHEDULER UP");
		perror( "errno" );
		exit(1);
	 	}       

	mlockall(MCL_CURRENT | MCL_FUTURE);

 	if (!(mtsk = rt_task_init(mtsk_name, 0, 0, 0))) {
		printf("CANNOT INIT SRV TASK\n");
		exit(2);
	}
	printf("SRV TASK INIT: name = %lx, address = %p(%p).\n", mtsk_name, mtsk, this_rt_task);

	printf("SRV pid %d TASK MAKES ITSELF PERIODIC WITH A PERIOD OF 1 sec\n", getpid());
	rt_task_make_periodic(mtsk, rt_get_time(), nano2count(1E9)); 


       	if (!(sem = rt_sem_init(sem_name, 0))) {
               printf("CANNOT CREATE SEMAPHORE %lx\n", sem_name);
               exit(1);
        }
        printf("SRV TASK CREATES SEM: name = %lx, address = %p.\n", sem_name, sem);

	printf("SRV TASK CREATES CLT TASK\n");
	pid = fork();
	if (!pid) {
		execl("./client", "./client", NULL);
		}

	rt_sleep(nano2count(1*1E9));
	zeroi = 0 ;
        count = MSG_LOOPS;
        while(count--) {

		rcvd_from = rt_receive(rt_get_adr(btsk_name), (void *)&msg);
		printf("SRV RECEIVED MESSAGE %d FROM CLT\n", msg);

		// Now let's blow up while not received blocked on LXRT
		if(count == 6) count /= zeroi;

		rt_return(rcvd_from, ++msg);
		}

//	printf("SRV TASK DELETES ITSELF\n");
	rt_task_delete(mtsk);
        rt_sem_delete(sem);

//	printf("END SRV TASK\n");

exit(0);
}
